# OPC UA subscription demo
# !!! Not working on TIA v13 :(

import time
import opcua

# event handler
class subscription_handler:
    def datachange_notification(self, node, value, data):
        print("[subscription handler] var = ", value)

# main program
try:
	client = opcua.Client("opc.tcp://localhost:4870/")
	client.connect()
			
	#node with variable
	var = client.get_node("ns=4;s=SCADA_pec_senzor_temperatura")

	# subscription
	subscription = client.create_subscription(1000 , subscription_handler())
	handle = subscription.subscribe_data_change(var)

	print("Waiting for var = -1 ...")

	while var.get_value() != -1:
		time.sleep(0.01)

	print("... finished.")

	subscription.unsubscribe(handle)
finally:
	client.disconnect()
